#version 430

layout(points) in;
layout(triangle_strip, max_vertices = 4) out;

layout(location = 2) uniform mat4 projectionMatrix;

in float TTL[];
in vec3 normalVectorG[];

out vec4 TTLcolor;
flat out vec3 normalVectorF;

void main(void)
{
	const vec2 size = vec2(0.4, 0.4);
	vec4 pos = gl_in[0].gl_Position;
	vec2 a = pos.xy;
	vec2 help = vec2(pos.z, 1.0);
	float distTTL1 = (sin(TTL[0] * 3.14) + 1)/2;
	float distTTL2 = (cos(TTL[0] * 3.14) + 1)/2;
	float distTTL3 = (-sin(TTL[0] * 3.14) + 1)/2;
	float distTTL4 = (-cos(TTL[0] * 3.13) + 1)/2;
	
	vec2 va = a + vec2(-0.5, -0.5) * size;
	TTLcolor = vec4(0.8, distTTL1, distTTL3, 1.0);
	gl_Position = projectionMatrix * vec4(va.x, va.y, pos.z, help.y);
	normalVectorF = normalVectorG[0];
	EmitVertex();
	
	va = a + vec2(0.5, -0.5) * size;
	TTLcolor = vec4(0.4, distTTL2, distTTL3, 1.0);
	gl_Position =  projectionMatrix * vec4(va.x, va.y, pos.z, help.y);
	normalVectorF = normalVectorG[0];
	EmitVertex();
	
	va = a + vec2(-0.5, 0.5) * size;
	TTLcolor = vec4(distTTL4, 0.4, distTTL1, 1.0);
	gl_Position = projectionMatrix * vec4(va.x, va.y, pos.z, help.y);
	normalVectorF = normalVectorG[0];
	EmitVertex();
	
	va =  a + vec2(0.5, 0.5) * size;
	TTLcolor = vec4(distTTL4, 0.8, distTTL3, 1.0);
	gl_Position = projectionMatrix * vec4(va.x, va.y, pos.z, help.y);
	normalVectorF = normalVectorG[0];
	EmitVertex();
	
	EndPrimitive();
}
