#version 430 core

// !IMPORTANT!
// If the locations are changed, they need to be changed in the program aswell.

layout(location = 0) in vec3 coordinates;
layout(location = 1) in vec3 normalVec;
layout(location = 9) in vec2 UVs;
layout(location = 11) in vec2 LMUVs;

out vertexInformation
{
	vec3 vertexWorldPosition;
} vertexInf;
out vec3 normalWorldOrientation;
out vec2 fragUVs;
out vec2 fragLMUVs;

layout(location = 2) uniform mat4 modelMatrix;
layout(location = 3) uniform mat4 normalMatrix;
layout(location = 4) uniform mat4 projectedCameraMatrix;


void main(void)
{
	normalWorldOrientation = vec3(normalMatrix * vec4(normalVec, 1.0));
	vec3 worldPos = vec3(modelMatrix * vec4(coordinates, 1.0));
	vertexInf.vertexWorldPosition = worldPos;
	fragUVs = UVs;
	fragLMUVs = LMUVs;
	gl_Position = projectedCameraMatrix * vec4(worldPos, 1.0);
}